#ifndef CHR_CURSOR_H
#define CHR_CURSOR_H

#include "chr_common.h"

#include "chr_table.h"
#include "chr_leaf.h"

class chr_cursor
{
public:
  chr_cursor(chr_table * table, size_t key_size, size_t value_size);
  ~chr_cursor();

  int move(const unsigned char * key, chr_pos_type type = CHR_KEY,
      chr_pos_where where = CHR_BEFORE);
  int insert(const unsigned char * key, const unsigned char * val);
  int del(const unsigned char * key);
  int update(const unsigned char * key, const unsigned char * val);
  int read_next(unsigned char * key, unsigned char * val);
  int read_prev(unsigned char * key, unsigned char * val);

private:
  void set_leaf(chr_leaf * leaf);
  const size_t key_size;
  const size_t value_size;
  chr_pos_where where;
  chr_table * const table;
  chr_leaf * leaf;
  unsigned char * curkey;
  int pos;

  unsigned char * prevkey;

  chr_cursor();
  chr_cursor & operator=(const chr_cursor &);
  chr_cursor(const chr_cursor &);
};

#endif /* CHR_CURSOR_H */

