#ifndef CHR_FLASH_H
#define CHR_FLASH_H

#include "chr_common.h"

#include <pthread.h>

#include "chr_lsn.h"
#include "chr_list.h"
#include "chr_flashgui.h"

/* nameless writes abstraction for flash memories */

class chr_flash
{
public:
  chr_flash(const char * device, const char * folder, chr_flashgui * ifc);
  ~chr_flash();
  int nameless_write(chr_lsn * lsn, const unsigned char * buf);
  int named_write(const chr_lsn lsn, const unsigned char * buf);
  void trim(const chr_lsn lsn);
  int read(const chr_lsn lsn, unsigned char * buf) const;
private:
  chr_flash(const chr_flash &);
  chr_flash & operator=(const chr_flash &);
  chr_list<chr_lsn, NULL_LSN> * free_sectors;
  chr_lsn max_lsn;
  int fd;
  char * desc_file;
  mutable pthread_mutex_t mutex;
  chr_flashgui * gui;

/* usefull experimental informations */
  mutable unsigned long long rd_count;
  mutable unsigned long long nw_count;
  mutable unsigned long long nlw_count;
  mutable unsigned long long tr_count;
};

#endif /* CHR_FLASH_H */

