#ifndef CHR_FLASHGUI_H
#define CHR_FLASHGUI_H

#include "chr_lsn.h"

class chr_flashgui
{
public:
#ifndef CHR_NO_GUI
  virtual ~chr_flashgui() {}
  virtual void set_size(const chr_lsn lsn) = 0;
  virtual void set_free(const chr_lsn lsn) = 0;
  virtual void set_used(const chr_lsn lsn) = 0;
  virtual void set_trimmed(const chr_lsn lsn) = 0;
  virtual void set_nl_writing(const chr_lsn lsn) = 0;
  virtual void unset_nl_writing(const chr_lsn lsn) = 0;
  virtual void set_writing(const chr_lsn lsn) = 0;
  virtual void unset_writing(const chr_lsn lsn) = 0;
  virtual void set_reading(const chr_lsn lsn) = 0;
  virtual void unset_reading(const chr_lsn lsn) = 0;
#else /* CHR_NO_GUI */
  inline chr_flashgui() {}
  inline ~chr_flashgui() {}
  inline void set_trimmed(const chr_lsn lsn) {}
  inline void set_free(const chr_lsn lsn) {}
  inline void set_used(const chr_lsn lsn) {}
  inline void set_size(const chr_lsn lsn) {}
  inline void set_nl_writing(const chr_lsn lsn) {}
  inline void unset_nl_writing(const chr_lsn lsn) {}
  inline void set_writing(const chr_lsn lsn) {}
  inline void unset_writing(const chr_lsn lsn) {}
  inline void set_reading(const chr_lsn lsn) {}
  inline void unset_reading(const chr_lsn lsn) {}
#endif /* CHR_NO_GUI */
};

#endif /* CHR_FLASHGUI_H */

