#ifndef CHR_FLASHGUI_TEXT_H
#define CHR_FLASHGUI_TEXT_H

#include "chr_common.h"

#include "chr_flashgui.h"
#include "chr_lsn.h"

class chr_flashgui_text : public chr_flashgui
{
public:
  chr_flashgui_text();
  virtual ~chr_flashgui_text();
  void set_trimmed(const chr_lsn lsn);
  void set_free(const chr_lsn lsn);
  void set_used(const chr_lsn lsn);
  void set_size(const chr_lsn lsn);
  void set_nl_writing(const chr_lsn lsn);
  void unset_nl_writing(const chr_lsn lsn);
  void set_writing(const chr_lsn lsn);
  void unset_writing(const chr_lsn lsn);
  void set_reading(const chr_lsn lsn);
  void unset_reading(const chr_lsn lsn);
private:
  void set_lastwrite(const chr_lsn lsn);

  chr_lsn size;
  unsigned long long rd_count;
  unsigned long long nw_count;
  unsigned long long nlw_count;
  unsigned long long tr_count;

  chr_flashgui_text(const chr_flashgui_text &);
  chr_flashgui_text & operator=(const chr_flashgui_text &);
};

#endif /* CHR_FLASHGUI_TEXT_H */

