#include "chr_ptr.h"

#include <stdio.h>
#include <assert.h>

#include "chr_flash.h"
#include "chr_parse.h"

chr_ptr & chr_ptr::operator=(const chr_ptr & other)
{
  if(other.is_memory())
  {
    this->ismemory = true;
    this->node = other.get_node();
  }
  else
  {
    this->ismemory = false;
    this->lsn = other.get_lsn();
  }
  return(*this);
}

chr_ptr & chr_ptr::operator=(chr_node * node)
{
  this->ismemory = true;
  this->node = node;
  return(*this);
}

chr_ptr & chr_ptr::operator=(chr_lsn lsn)
{
  this->ismemory = false;
  this->lsn = lsn;
  return(*this);
}

chr_ptr::chr_ptr(const chr_ptr & other)
{
  *this = other;
}

chr_ptr::chr_ptr(chr_node * node)
{
  *this = node;
}

chr_ptr::chr_ptr(chr_lsn lsn)
{
  *this = lsn;
}

bool chr_ptr::is_memory() const
{
  return(this->ismemory);
}

chr_node * chr_ptr::get_node() const
{
  assert(is_memory());
  return(this->node);
}

chr_lsn chr_ptr::get_lsn() const
{
  assert(!(this->is_memory()));
  return(this->lsn);
}

