#ifndef CHR_PTR_H
#define CHR_PTR_H

#include "chr_common.h"

#include "chr_node.h"

class chr_ptr
{
public:
  chr_ptr & operator=(const chr_ptr & other);
  chr_ptr & operator=(chr_node * node);
  chr_ptr & operator=(chr_lsn lsn);
  chr_ptr(const chr_ptr & other);
  chr_ptr(chr_node * node);
  chr_ptr(chr_lsn lsn);

  bool is_memory() const;
  chr_node * get_node() const;
  chr_lsn get_lsn() const;
protected:
  union
  {
    chr_node * node;
    chr_lsn lsn;
  };
private:
  bool ismemory;
};

#endif /* CHR_PTR_H */

