#ifndef CHR_TABLE_H
#define CHR_TABLE_H

#include "chr_common.h"

#include "chr_flash.h"
#include "chr_btreegui.h"

class chr_cursor;
class chr_node;
class chr_leaf;
class chr_btreegui_latex;

class chr_table
{
public:
  chr_table(const size_t key_size, const size_t value_size,
      chr_flash * flash, const chr_lsn root_lsn = NULL_LSN);
  ~chr_table();

  int drop();
  chr_cursor * open_cursor(const unsigned char * key,
      chr_pos_type type = CHR_KEY);
  chr_lsn close();
  chr_leaf * search(const unsigned char * key, chr_pos_type type = CHR_KEY);
  size_t get_value_size();
  size_t get_key_size();
  const chr_flash * get_flash();
  void dbug_print();
  void dbug_check();
#ifndef CHR_NO_GUI
  void print();
#else /* CHR_NO_GUI */
  inline void print() {}
#endif /* CHR_NO_GUI */

private:
  const size_t key_size;
  const size_t value_size;
  chr_flash * const flash;
  chr_btreegui * btreegui;
  chr_btreegui_latex * btreegui_dbug;
public:
  chr_node * root;
  chr_lsn root_lsn;
private:
  chr_table & operator=(const chr_table &);
  chr_table(const chr_table &);
};

#endif /* CHR_TABLE_H */

